#ifndef _COOKIE_H
#define _COOKIE_H

#define COOK_NOTFOUND 0
#define COOK_INSERT   1
#define COOK_REPLACE  2

#define COOK_DELETE   1


struct cookie {
    char *name;
    char *value;
    struct cookie *next;
    };

struct cookie_list {
    struct cookie *head;
    struct cookie *tail;
    int sz;
    };

struct cook_tree_list_e {
    struct cook_tree        *ln;
    struct cook_tree_list_e *next;
    };

struct cook_tree_list {
    struct cook_tree_list_e *head;
    struct cook_tree_list_e *tail;
    int sz;
    };

struct cook_tree {
    char  *name;
    struct cookie_list *cookie_list;
    struct cook_tree_list *sons;
    };


struct cook_tree *cook_tree_init(void);
void   cook_tree_destroy(struct cook_tree *);

int   cookie_insert(char *, struct cook_tree *);
void  cookie_set(char *, char *, char *, struct cook_tree *);
char *cookie_build(char *, struct cook_tree *);

void cookie_print(char *, struct cook_tree *);

extern struct cook_tree *cookie_tree;

#endif
